cordova.define("com.provider.bluetooth.ProviderBluetoothSerial", function(require, exports, module) {
var cordova = require("cordova");
var exec    = require("cordova/exec");

var ProviderBluetoothSerial = function() {
  this.connect = function( name, address, success, error ) {
    var successHandler = function( data ) {
      if( data == "endfare" ) {
        cordova.fireDocumentEvent( "endfare" );
      } else if( data == "startfare" ) {
        cordova.fireDocumentEvent( "startfare" );
      } else if( data == "OK" ) {
        cordova.fireDocumentEvent( "onbluetoothConnect" );
      }

      return success();
    };

    var errorHandler =  function() {
      cordova.fireDocumentEvent( "onbluetoothDisconnect" );
      return error();
    };

    exec( successHandler, errorHandler, "ProviderBluetoothSerial", "connect", [ name, address ] );
  };

  this.connectInsecure = function( address, success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "connectInsecure", [ address ] );
  };

  this.disconnect = function( success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "disconnect", [] );
  };

  this.list = function( success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "list", [] );
  };

  this.isEnabled = function( success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "isEnabled", [] );
  };

  this.isConnected = function( success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "isConnected", [] );
  };

  this.available = function( success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "available", [] );
  };

  this.clear = function( success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "clear", [] );
  };

  this.read = function( success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "read", [] );
  };

  this.write = function( data, success, error ) {
    exec( success, error, "ProviderBluetoothSerial", "write", [ data ] );
  };
};

module.exports = new ProviderBluetoothSerial();

});
